//----------------------------------------------------------------
// main.cpp
//----------------------------------------------------------------
// Copyright of John Wong 1998
//
// You are free to use this source code as long as it is for
// non-commercial use and this copyright notice is retained.
//----------------------------------------------------------------
// Revision History
//
// [JW-MAY.22.1998] v01.00  John Wong
//----------------------------------------------------------------

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

HINSTANCE	g_hInstance = NULL;
HWND		g_hWndMain = NULL;

LRESULT CALLBACK WindowProc(  
							HWND hwnd,		// handle to window
							UINT uMsg,		// message identifier
							WPARAM wParam,	// first message parameter
							LPARAM lParam);	// second message parameter

int WINAPI WinMain(  
	HINSTANCE a_hInstance,		// handle to current instance
	HINSTANCE a_hPrevInstance,	// handle to previous instance
	LPSTR a_lpCmdLine,			// pointer to command line
	int a_nCmdShow)				// show state of window
{
    MSG msg;     
	WNDCLASS wc;     
	
    // register the main window class
    wc.style = 0;         
	wc.lpfnWndProc = (WNDPROC) WindowProc; 
	wc.cbClsExtra = 0;         
	wc.cbWndExtra = 0; 
	wc.hInstance = a_hInstance;         
	wc.hIcon = LoadIcon((HINSTANCE) NULL, IDI_APPLICATION);         
	wc.hCursor = LoadCursor((HINSTANCE) NULL, IDC_ARROW);         
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH); 
	wc.lpszMenuName =  NULL; 
	wc.lpszClassName = "MainWndClass";          
	if (!RegisterClass(&wc)) 
	{
		return FALSE;     
	}
	
    g_hInstance = a_hInstance;  // save instance handle      
	
	// Create the main window. 
	g_hWndMain = CreateWindow(
		"MainWndClass", 
		"Sample 1", 
        WS_OVERLAPPEDWINDOW, 
		CW_USEDEFAULT, 
		CW_USEDEFAULT, 
        CW_USEDEFAULT, 
		CW_USEDEFAULT, 
		(HWND) NULL, 
        (HMENU) NULL, 
		g_hInstance, 
		(LPVOID) NULL);  
	
    // If the main window cannot be created, terminate     
	// the application.  
    if (!g_hWndMain)         
	{
		return FALSE;
	}
    
	// Show the window and paint its contents.  
    ShowWindow(g_hWndMain, a_nCmdShow);     
	UpdateWindow(g_hWndMain);  
	
    // Start the message loop.      
	while (GetMessage(&msg, (HWND) NULL, 0, 0)) 
    {         
		TranslateMessage(&msg);         
		DispatchMessage(&msg);     
	}  
    
	// Return the exit code to Windows.      
	return msg.wParam; 
}

LRESULT CALLBACK WindowProc(  
	HWND a_hwnd,		// handle to window
	UINT a_uMsg,		// message identifier
	WPARAM a_wParam,	// first message parameter
	LPARAM a_lParam)	// second message parameter
{
	switch (a_uMsg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	default:
		return DefWindowProc(a_hwnd, a_uMsg, a_wParam, a_lParam);
	}
}

